﻿
; Sift2
; https://www.autoitscript.com/forum/topic/40843-calculate-string-similarity/?tab=comments#comment-642358

#include <File.au3>
#include <Math.au3>
#include <Array.au3>
#include <Timers.au3>

Dim Const $maxOffset = 5 ; Change according to how far you want to search; a bigger value means a slower comparison

$corrcount = 0

$segfod = FileOpenDialog ("Select files containing segments", @ScriptDir, "All (*.*)")
$segfo = FileOpen ($segfod, 128)

$resultfsd = FileSaveDialog ("Select name of output file", @ScriptDir, "All (*.*)", 18, $segfod & "_output.txt")
$resultfo = FileOpen ($resultfsd, 129)

$similarsfsd = FileSaveDialog ("Select name of output file", @ScriptDir, "All (*.*)", 18, $resultfsd & "_similars.txt")
$similarsfo = FileOpen ($similarsfsd, 129)
 



$fuzzythreshold = InputBox ("", "Fuzzy threshold? 75 means '75% similarity or higher'. A lower number will result in more matches.", "75")

$lengththreshold = InputBox ("", "Length threshold? 1.0 means sentences must be identical; 0.75 means sentences outside of 75% of each other's length are not checked.", "0.75")
$spacelimit = InputBox ("", "Space limit? 5 means sentences of 4 or fewer spaces are not checked. Type 'N' to disable space limit.", "5")

$comparespacelimit = 0
$comparespacelimitreport = "No"
If $spacelimit <> "N" Then
$comparespacelimit = MsgBox (4, "Global space limit?", "Should we apply a space limit also to sentences that are being compared to the current sentence?", 0)
If $comparespacelimit = 6 Then ; yes
$comparespacelimitreport = "Yes"
Else
$comparespacelimitreport = "No"
EndIf
EndIf

$lengthlimit = InputBox ("", "Length limit? Sentences shorter than this are not checked. Type 'N' to disable length limit.", "10")
$upperlengthlimit = InputBox ("", "Upper length limit? Sentences LONGER than this are not checked. Type 'N' to disable length limit.", "N")
$methodused = "fuzzy trim, type 2 (sift2) v.3"

$segfr = FileRead ($segfo)

; The time stamps are for testing purposes only
$time1 = _Timer_Init ()
$time2 = "0"
$time3 = "0"

$listsplit = StringSplit ($segfr, @CRLF, 1)

$proccount = $listsplit[0]

For $outerloop = 1 to $listsplit[0] - 1

$firstline = $listsplit[$outerloop]

If $lengthlimit <> "N" Then
If StringLen ($firstline) < $lengthlimit Then
FileWrite ($resultfo, Round ((_Timer_Diff ($time1))/1000, 3) & @TAB & $firstline & @TAB & "(too short)" & @CRLF)
$proccount = $proccount - 1
ContinueLoop
EndIf
EndIf

If $upperlengthlimit <> "N" Then
If StringLen ($firstline) > $upperlengthlimit Then
FileWrite ($resultfo, Round ((_Timer_Diff ($time1))/1000, 3) & @TAB & $firstline & @TAB & "(too long)" & @CRLF)
$proccount = $proccount - 1
ContinueLoop
EndIf
EndIf

If $spacelimit <> "N" Then
$spacelimitcheck = StringReplace ($firstline, " ", " ")
If @extended < $spacelimit Then
FileWrite ($resultfo, Round ((_Timer_Diff ($time1))/1000, 3) & @TAB & $firstline & @TAB & "(too few spaces)" & @CRLF)
$proccount = $proccount - 1
ContinueLoop
EndIf
EndIf




; If $outerloop = 1 Then
; ToolTip ("Now processing line " & $outerloop & " of approx " & $proccount & " remaining" & @CRLF & $firstline, 200, 200)
; Else
ToolTip ("Now processing line " & $outerloop & "; Approx " & $proccount & " lines remaining; " & $corrcount & " matches found so far." & @CRLF & @CRLF & Round ((_Timer_Diff ($time1))/1000, 3) & " seconds since start" & @CRLF & Round ((_Timer_Diff ($time2))/1000, 3) & " seconds since previous segment" & @CRLF & Round (((_Timer_Diff ($time1))/1000) / $outerloop, 3) & " average seconds per segment so far", 200, 200)
; EndIf


If StringInStr ($listsplit[$outerloop], "::!!!::") Then
$proccount = $proccount - 1
ContinueLoop
Else
FileWrite ($resultfo, Round ((_Timer_Diff ($time1))/1000, 3) & @TAB & $firstline & @TAB & "(no match)" & @CRLF)
$proccount = $proccount - 1
EndIf

$time2 = _Timer_Init ()






For $innerloop = $outerloop + 1 to $listsplit[0]

$otherline = $listsplit[$innerloop]

If StringInStr ($otherline, "::!!!::") Then
ContinueLoop
EndIf

If $comparespacelimit = 6 Then
$spacelimitcheck = StringReplace ($otherline, " ", " ")
If @extended > ($spacelimit / $lengththreshold) Then
ContinueLoop
EndIf
EndIf

If StringLen ($otherline) < ($lengthlimit * $lengththreshold) Then
ContinueLoop
EndIf

If StringLen ($firstline) / StringLen ($otherline) < $lengththreshold Then
ContinueLoop
EndIf
If StringLen ($firstline) / StringLen ($otherline) > (1 / $lengththreshold) Then
ContinueLoop
EndIf







$simsim = Int (_Similarity($firstline, $otherline))

If $simsim > $fuzzythreshold Then
FileWrite ($resultfo, Int ((_Timer_Diff ($time1))/1000) & @TAB & "{{" & $otherline & "}}" & @TAB & $simsim & @CRLF)
FileWrite ($similarsfo, $firstline & @TAB & $simsim & @TAB & $otherline & @CRLF)
$listsplit[$innerloop] = $listsplit[$innerloop] & "::!!!::"
$corrcount = $corrcount + 1
$proccount = $proccount - 1
EndIf

Next

; $time3 = _Timer_Init ()

Next

ToolTip ("")

$finalreport = "" 
$finalreport = $finalreport & "=========|=========|=========|=========|=========" & @CRLF
$finalreport = $finalreport & @CRLF 
$finalreport = $finalreport & "Input file: " & StringReplace ($segfod, @ScriptDir & "\", "") & @CRLF
$finalreport = $finalreport & "Output file: " & StringReplace ($resultfsd, @ScriptDir & "\", "") & @CRLF
$finalreport = $finalreport & "Fuzzy threshold: " & $fuzzythreshold & "%" & @CRLF
$finalreport = $finalreport & "Length threshold: " & $lengththreshold & @CRLF
$finalreport = $finalreport & "Space limit: " & $spacelimit & @CRLF
$finalreport = $finalreport & "Global space limit: " & $comparespacelimitreport & @CRLF
$finalreport = $finalreport & "Length limit: " & $lengthlimit & @CRLF
$finalreport = $finalreport & "Upper length limit: " & $upperlengthlimit & @CRLF
$finalreport = $finalreport & "Method used: " & $methodused & @CRLF
$finalreport = $finalreport & @CRLF 
$finalreport = $finalreport & "Total time: " & Round ((_Timer_Diff ($time1))/1000, 3) & " seconds" & @CRLF
$finalreport = $finalreport & "# of segments: " & $listsplit[0] & @CRLF
$finalreport = $finalreport & "# of matches: " & $corrcount & @CRLF
$finalreport = $finalreport & @CRLF 
$finalreport = $finalreport & "=========|=========|=========|=========|=========" & @CRLF

FileWrite ($resultfo, @CRLF & @CRLF & @CRLF & $finalreport & @CRLF & @CRLF & @CRLF)

MsgBox (0, "Done!", $finalreport, 0)

Exit


; ========================================================================================================


; Compute similarity between two strings
Func _Similarity($s1, $s2, $alg = 0)
    Local $dis
    If ($alg = 0) Then
        $dis = _Levenshtein($s1, $s2)
    Else 
        $dis = _Distance($s1, $s2)
    EndIf
    Local $maxLen = _Max(StringLen($s1), StringLen($s2))
    If ($maxLen = 0) Then Return 100
    Return (1 - $dis / $maxLen) * 100
EndFunc

; Compute Levenshtein Distance
Func _Levenshtein($s, $t)
    Local $m, $n, $i, $j, $s_i, $t_j, $cost

    $n = StringLen($s)
    $m = StringLen($t)

    If $n * $m = 0 Then Return $m + $n

    Local $d[$n + 1][$m + 1]
    
    For $i = 0 To $n
        $d[$i][0] = $i
    Next
    
    For $j = 0 To $m
        $d[0][$j] = $j
    Next

    For $i = 1 To $n
        $s_i = StringMid($s, $i, 1)
        
        For $j = 1 To $m
            $t_j = StringMid($t, $j, 1)

            If $s_i = $t_j Then
                $cost = 0
            Else
                $cost = 1
            EndIf
            
            $d[$i][$j] = _Minimum3($d[$i - 1][$j] + 1, $d[$i][$j - 1] + 1, $d[$i - 1][$j - 1] + $cost)
        Next
    Next

    Return $d[$n][$m]
  
EndFunc

; Get minimum of three values
Func _Minimum3($a, $b, $c)
    Local $mi

    $mi = $a
    If $b < $mi Then $mi = $b
    If $c < $mi Then $mi = $c
    
    Return $mi
EndFunc

; Efficient calculation of similarity
Func _Distance($s1, $s2)
    Local $ls1 = StringLen($s1), $ls2 = StringLen($s2)
    If $ls1 * $ls2 = 0 Then Return $ls1 + $ls2
    
    Local $c = 0, $offset1 = 0, $offset2 = 0, $dist = 0, $i
    
    While (($c + $offset1 < $ls1) And ($c + $offset2 < $ls2))
        If (StringMid($s1, $c + $offset1 + 1, 1) <> StringMid($s2, $c + $offset2 + 1, 1)) Then
            $offset1 = 0
            $offset2 = 0
            For $i = 0 to $maxOffset - 1
                If (($c + $i < $ls1) And (StringMid($s1, $c + $i + 1, 1) = StringMid($s2, $c + 1, 1))) Then
                    If ($i > 0) Then
                        $dist += 1
                        $offset1 = $i
                    EndIf
                    $dist -= 1
                    ExitLoop
                EndIf
                If (($c + $i < $ls2) And (StringMid($s1, $c + 1, 1) = StringMid($s2, $c + $i + 1, 1))) Then
                    If ($i > 0) Then
                        $dist += 1
                        $offset2 = $i
                    EndIf
                    $dist -= 1
                    ExitLoop
                EndIf
            Next
            $dist += 1
        EndIf
        $c += 1
    Wend
    
    Return $dist + ($ls1 - $offset1 + $ls2 - $offset2) / 2 - $c
EndFunc